import { Injectable } from '@nestjs/common';
import { BaseDeleteManager } from 'src/core/modules/domain/usecase/managers/base-delete.manager';
import { BannerEntity } from '../../entities/banner.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { BannerModel } from '../../../data/models/banner.model';
import { BannerDeletedEvent } from '../../entities/event/banner-deleted.event';

@Injectable()
export class DeleteBannerManager extends BaseDeleteManager<BannerEntity> {
  getResult(): string {
    return `Success`;
  }

  async validateProcess(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return BannerModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: BannerDeletedEvent,
        data: this.data,
      },
    ];
  }
}
